# Holeg Simulator

Cyber-physical systems simulation software following a Holon-based smart grid system.

## Prerequisites

* Java 1.8 compatible VM
* Gradle >= 3.1 (may be downloaded on-the-fly)

## Building

This project uses Gradle. If Gradle is not available on your system, run the included shell 
script `gradlew` (or `gradlew.bat` on Windows) instead of the `gradle` command.

### Available tasks

	$ gradle build		# Assembles and tests this project.
	
	$ gradle test		# Runs the included unit tests.
	
	$ gradle run		# Starts the Holeg Simulator as JVM Application.
	
	$ gradle tasks		# Displays all the tasks runnable from root project.

## Introduction and User Manual

The Wiki contains some general [Information](https://git.tk.informatik.tu-darmstadt.de/carlos.garcia/praktikum-holons/wiki/Introduction) and a [User Manual](https://git.tk.informatik.tu-darmstadt.de/carlos.garcia/praktikum-holons/wiki/User+Manual)

## API Instructions

Check out the [API Instructions Wiki](https://git.tk.informatik.tu-darmstadt.de/carlos.garcia/praktikum-holons/wiki/Algorithms) for some Instructions

## License

This project is licensed under a modified MIT License - see the [LICENSE.md](https://git.tk.informatik.tu-darmstadt.de/carlos.garcia/praktikum-holons/src/BP_master/license.md) file for details
	
## Built With

* [JUnit](http://junit.org) - The used test system
* [Gson](https://github.com/google/gson) - Used for Saving/Loading
* [Apache Common Compress ](https://rometools.github.io/rome/) - Creates zip/tar Archives

## Contributors

### Version 1.0 to 1.1.0

*  Kevin Julian Trometer
*  Dominik Fabio Rieder
*  Teh-Hai Julian Zheng
*  Edgardo Ernesto Palza Paredes
*  Jessey Steven Widhalm

### Version 2.0

*  Isabella Dix
*  Carlos Garcia

### Version TBA

*  Andreas T. Meyer-Berg
*  Ludwig Tietze
*  Antonio Schneider
*  Tom Troppmann

## Under contract from:

*  Darmstadt University of Technology
*  Department of Computer Science, Telecooperation
*  Hochschulstr. 10
*  Informatik Telecooperation Lab (TK)
*  D-64289 Darmstadt, Germany

### Version 1.0 to 1.1.0

*  Andreas Tundis
*  Carlos Garcia

### Version TBA

*  Rolf Egert
